{-# LINE 175 "thesisCodeIG.hs" #-}
{-#  LANGUAGE GADTs  #-}
{-#  LANGUAGE KindSignatures  #-}
{-#  LANGUAGE TypeFamilies  #-}
{-#  LANGUAGE TypeOperators  #-}
{-#  LANGUAGE FlexibleContexts  #-}
{-#  LANGUAGE FlexibleInstances  #-}
{-#  LANGUAGE TypeSynonymInstances  #-}

module ThesisCodeIG where

type List = []
{-# LINE 193 "thesisCodeIG.hs" #-}
data U          = U_
data Var aT     = Var_ aT
data Rec aT     = Rec_ aT
data aT :+: bT  = L_ aT | R_ bT
data aT :*: bT  = aT ::*:: bT
{-# LINE 209 "thesisCodeIG.hs" #-}
class Representable aT where
  type Rep aT
  to    :: Rep aT   -> aT
  from  :: aT       -> Rep aT
{-# LINE 221 "thesisCodeIG.hs" #-}
instance Representable (List aT) where
  type Rep (List aT) = U :+: (Var aT :*: Rec (List aT))

  from []                        = L_  U_
  from (h : t)                  = R_  (Var_ h ::*:: Rec_ t)

  to (L_  U_)                     = []
  to (R_  (Var_ h ::*:: Rec_ t))  = h : t
{-# LINE 242 "thesisCodeIG.hs" #-}
class Crush' aT where
  crush' :: (rT -> rT -> rT) -> (rT -> rT) -> rT -> aT -> rT
{-# LINE 250 "thesisCodeIG.hs" #-}
instance Crush' U where
  crush' _ _ z _ = z
  
instance (Crush' aT, Crush' bT) => Crush' (aT :+: bT) where
  crush' f g z (L_  x) = crush' f g z x
  crush' f g z (R_  x) = crush' f g z x

instance (Crush' aT, Crush' bT) => Crush' (aT :*: bT) where
  crush' f g z (x ::*:: y) = f (crush' f g z x) (crush' f g z y)
{-# LINE 263 "thesisCodeIG.hs" #-}
instance Crush' (Var aT) where
  crush' f g z (Var_ x) = z
{-# LINE 271 "thesisCodeIG.hs" #-}
instance (Crush aT) => Crush' (Rec aT) where
  crush' f g z (Rec_ x) = g (crush f g z x)
{-# LINE 281 "thesisCodeIG.hs" #-}
class Crush aT where
  crush :: (rT -> rT -> rT) -> (rT -> rT) -> rT -> aT -> rT
{-# LINE 287 "thesisCodeIG.hs" #-}
crushDefault ::  (Representable aT, Crush' (Rep aT)) =>
                 (rT -> rT -> rT) -> (rT -> rT) -> rT -> aT -> rT
crushDefault f g z = crush' f g z . from
{-# LINE 295 "thesisCodeIG.hs" #-}
instance Crush (List aT) where
  crush = crushDefault
{-# LINE 317 "thesisCodeIG.hs" #-}
size :: (Crush aT) => aT -> Int
size = crush (+) (+1) 0
