{-# LINE 143 "thesisCodePolyP.hs" #-}
{-#  LANGUAGE TypeOperators               #-}
{-#  LANGUAGE GADTs                       #-}
{-#  LANGUAGE TypeFamilies                #-}
{-#  LANGUAGE FlexibleContexts            #-}
{-#  LANGUAGE UndecidableInstances        #-}
module ThesisCodePolyP where
  
  type List = []
{-# LINE 161 "thesisCodePolyP.hs" #-}
  data U             pT aT  = U_
  data I             pT aT  = I_ { unI :: aT }
  data P             pT aT  = P_ pT
  data K bT          pT aT  = K_ bT
  data (fT  :+:  gT)  pT aT  = L_ (fT pT aT) | R_ (gT pT aT)
  data (fT  :*:  gT)  pT aT  = fT pT aT ::*::  gT pT aT
  data (dT  :.:  fT)  pT aT  = Comp (Fix dT (fT pT aT))
{-# LINE 182 "thesisCodePolyP.hs" #-}
  data Fix dT pT = In { out :: dT pT (Fix dT pT) }
{-# LINE 193 "thesisCodePolyP.hs" #-}
  class Bimap fT where
    bimap :: (aT -> bT) -> (cT -> dT) -> fT aT cT -> fT bT dT
   
  instance Bimap U where
    bimap _ _  U_            = U_

  instance Bimap P where
    bimap f _  (P_ x)        = P_ (f x)

  instance Bimap I where
    bimap _ g  (I_ r)        = I_ (g r)

  instance Bimap (K aT) where
    bimap _ _  (K_ x)        = K_ x

  instance (Bimap fT, Bimap gT) => Bimap (fT :+: gT) where
    bimap f g  (L_ x)         = L_  (bimap f g x)
    bimap f g  (R_ x)         = R_  (bimap f g x)

  instance (Bimap fT, Bimap gT) => Bimap (fT :*: gT) where
    bimap f g  (x ::*:: y)    = bimap f g x ::*:: bimap f g y

  instance (Bimap dT, Bimap fT) => Bimap (dT :.: fT) where
    bimap f g  (Comp x)       = Comp (pmap (bimap f g) x)
{-# LINE 222 "thesisCodePolyP.hs" #-}
  pmap :: (Bimap dT) => (aT -> bT) -> Fix dT aT -> Fix dT bT
  pmap f = In . bimap f (pmap f) . out
{-# LINE 235 "thesisCodePolyP.hs" #-}
  class PolyP (dT :: * -> *) where
    type PF dT  :: * -> * -> *

    from        :: dT pT            -> Fix (PF dT) pT
    to          :: Fix (PF dT) pT   -> dT pT
{-# LINE 257 "thesisCodePolyP.hs" #-}
  instance PolyP [] where
    type PF [] = U :+: (P :*: I)

    from []        = In (L_ U_)
    from (h : t)  = In (R_ (P_ h ::*:: I_ (from t)))
    
    to (In (L_ U_))                 = []
    to (In (R_ (P_ h ::*:: I_ t)))  = h : to t
{-# LINE 269 "thesisCodePolyP.hs" #-}
  data Rose pT = Rose_ pT (List (Rose pT))
{-# LINE 273 "thesisCodePolyP.hs" #-}
  instance PolyP Rose where
    type PF Rose = P :*: (PF [] :.: I)

    from (Rose_ x l) = In (P_ x ::*:: Comp (pmap (I_ . from) (from l)))
    to (In (P_ x ::*:: Comp l)) = Rose_ x (to (pmap (to . unI) l))
{-# LINE 288 "thesisCodePolyP.hs" #-}
  gfmap :: (PolyP dT, Bimap (PF dT)) => (aT -> bT) -> dT aT -> dT bT
  gfmap f = to . pmap f . from
