{-# LINE 149 "thesiscodeRegular.hs" #-}
{-#  LANGUAGE TypeOperators               #-}
{-#  LANGUAGE GADTs                       #-}
{-#  LANGUAGE TypeFamilies                #-}
{-#  LANGUAGE FlexibleContexts            #-}
{-#  LANGUAGE TypeSynonymInstances        #-}
module ThesisCodeRegular where

  type List = []
{-# LINE 165 "thesiscodeRegular.hs" #-}
  data U            aT   = U_
  data I            aT   = I_ aT
  data K bT         aT   = K_ bT
  data (fT :+: gT)  aT   = L_ (fT aT) | R_ (gT aT)
  data (fT :*: gT)  aT   = fT aT ::*:: gT aT
{-# LINE 209 "thesiscodeRegular.hs" #-}
  instance Functor U where
    fmap _  U_             = U_

  instance Functor I where
    fmap f  (I_ r)         = I_ (f r)

  instance Functor (K aT) where
    fmap _  (K_ x)         = K_ x

  instance (Functor fT, Functor gT) => Functor (fT :+: gT) where
    fmap f  (L_  x)        = L_  (fmap f x)
    fmap f  (R_  x)        = R_  (fmap f x)

  instance (Functor fT, Functor gT) => Functor (fT :*: gT) where
    fmap f  (x ::*:: y)    = fmap f x ::*:: fmap f y
{-# LINE 234 "thesiscodeRegular.hs" #-}
  class Regular aT where
    type PF aT  :: * -> *

    from        :: aT        -> PF aT aT
    to          :: PF aT aT  -> aT
{-# LINE 251 "thesiscodeRegular.hs" #-}
  data Nat = Ze | Su Nat
   
  instance Regular Nat where
    type PF Nat = U :+: I

    from Ze       = L_ U_
    from (Su n)   = R_ (I_ n)

    to (L_ U_)       = Ze
    to (R_ (I_ n))   = Su n
{-# LINE 269 "thesiscodeRegular.hs" #-}
  data Fix fT = In (fT (Fix fT))

  deepFromNat :: Nat -> Fix (PF Nat)
  deepFromNat = In . fmap deepFromNat . from
{-# LINE 284 "thesiscodeRegular.hs" #-}
  class GLength fT where
    glength :: fT Int -> Int
   
  instance GLength U where
    glength _           = 0

  instance GLength I where
    glength (I_ n)      = n + 1

  instance GLength (K aT) where
    glength _           = 0

  instance (GLength fT, GLength gT) => GLength (fT :+: gT) where
    glength (L_  x)      = glength x
    glength (R_  x)      = glength x

  instance (GLength fT, GLength gT) => GLength (fT :*: gT) where
    glength (x ::*:: y) = glength x + glength y
{-# LINE 309 "thesiscodeRegular.hs" #-}
  cata' :: (Regular aT, Functor (PF aT)) => (PF aT bT -> bT) -> aT -> bT
  cata' f x = f (fmap (cata' f) (from x))
{-# LINE 316 "thesiscodeRegular.hs" #-}
  glengthdefault :: (Regular aT, Functor (PF aT), GLength (PF aT)) => aT -> Int
  glengthdefault = cata' glength
{-# LINE 324 "thesiscodeRegular.hs" #-}
  instance Regular (List aT) where
    type PF (List aT) = U :+: (K aT :*: I)

    from []         = L_ U_
    from (h : t)   = R_ (K_ h ::*:: I_ t)

    to (L_ U_)                  = []
    to (R_ (K_ h ::*:: I_ t))   = h : t
